// cl Demo30.cpp Strings.cpp /O1 /Os /GS- /Zc:sizedDealloc- TCLib.lib kernel32.lib user32.lib
#include <windows.h>
#include "stdlib.h"
#include "stdio.h"
#include "Strings.h"

String bar (String  fs)
{
 String  fs1 = fs.UCase();
 return fs1;
}

void fu()
{
 String  fs1 = "hello";
 String  fs2;
 fs2 = bar(fs1);
 fs2.Print( true);
} 

int main()
{
 fu();
 getchar();
    
 return 0;
}

Four String Objects Are Created:

2446283589488
2446283595008
2446283595040
2446283595072

And Four Are Destroyed:

2446283595040
2446283595072
2446283595008
2446283589488

Console Output:

Entering String::String(const TCHAR* pStr)                     <<< String  fs1 = "hello";     << Construct String From TCHAR*
  this->lpBuffer = 2446283589488
  this->lpBuffer = hello
Leaving String::String(const TCHAR* pStr)

Entering Uninitialized Constructor!                            <<< String  fs2;               << Construct Uninitialized String; This is the 008 String.
  this->lpBuffer = 2446283595008
Leaving Uninitialized Constructor!

Entering String::String(const String& s)                       <<< fs2 = bar(fs1);            << Copy Constructor Makes Copy of fs1 For Function Parameter, and its 040
  this->lpBuffer = 2446283595040
  this->lpBuffer = hello
Leaving String::String(const String& s)

Entering String String::UCase()                                <<< String fs1 = fs.UCase();   << Call String::UCase()
  Entering String::String(const String& s)                     <<< String fs1                 << But 1st need to assign parameter String fs to local String fs1
    this->lpBuffer = 2446283595072                                                            << The 072 String points to "hello"
    this->lpBuffer = hello                                                                    << The 072 String is now "HELLO"
  Leaving String::String(const String& s)
  s.lpBuffer = 2446283595072                                                                                        
  s.lpBuffer = HELLO
Leaving String String::UCase()

Entering String Destructor!                                                                   << Destroy the 040 String constructed for the function parameter
  this->lpBuffer = 2446283595040
Leaving String Destructor!

Entering String& String::operator=(const String& strAnother)   <<< fs2 = bar(fs1);            << The 008 String gets "HELLO" assigned to it;     
  this->lpBuffer = 2446283595008
Leaving String& String::operator=(const String& strAnother)

Entering String Destructor!                                    << Destroy the 072 String Constructed in String::UCase()
  this->lpBuffer = 2446283595072
Leaving String Destructor!

HELLO                                                          <<< fs2.Print( true);          << Output result                                                                

Entering String Destructor!                                    << Destroy fs2 in fu
  this->lpBuffer = 2446283595008
Leaving String Destructor!

Entering String Destructor!                                    << Destroy fs1 from fu
  this->lpBuffer = 2446283589488
Leaving String Destructor!
